//+------------------------------------------------------------------+
//|                                                      _DeMark.mq4 |
//|                                                            Boris |
//|                                                |
//+------------------------------------------------------------------+
#property copyright "Boris"


#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 DarkOrange
#property indicator_color4 DeepSkyBlue
#property indicator_color5 OrangeRed
#property indicator_color6 BlueViolet

#import "user32.dll"
  bool GetClientRect (int h, int& pos[4]);
#import

//---- input parameters

//---- buffers
double TD_1_UpBuffer[]; 
double TD_1_DownBuffer[];
double TD_2_UpBuffer[];
double TD_2_DownBuffer[];
double TD_3_UpBuffer[];
double TD_3_DownBuffer[];

//---- 
double indent;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
   {
//---- indicator buffers mapping  
      SetIndexBuffer(0,TD_1_UpBuffer);
      SetIndexBuffer(1,TD_1_DownBuffer);   
      SetIndexBuffer(2,TD_2_UpBuffer);
      SetIndexBuffer(3,TD_2_DownBuffer);   
      SetIndexBuffer(4,TD_3_UpBuffer);
      SetIndexBuffer(5,TD_3_DownBuffer);   
//---- drawing settings
      SetIndexStyle(0,DRAW_ARROW,0,2);
      SetIndexArrow(0,140);
      SetIndexStyle(1,DRAW_ARROW,0,2);
      SetIndexArrow(1,140);
      SetIndexStyle(2,DRAW_ARROW,0,2);
      SetIndexArrow(2,141);
      SetIndexStyle(3,DRAW_ARROW,0,2);
      SetIndexArrow(3,141);
      SetIndexStyle(4,DRAW_ARROW,0,2);
      SetIndexArrow(4,142);
      SetIndexStyle(5,DRAW_ARROW,0,2);
      SetIndexArrow(5,142);
//----
      SetIndexEmptyValue(0,0.0);
      SetIndexEmptyValue(1,0.0);
      SetIndexEmptyValue(2,0.0);
      SetIndexEmptyValue(3,0.0);
      SetIndexEmptyValue(4,0.0);
      SetIndexEmptyValue(5,0.0);
//---- name for DataWindow
      SetIndexLabel(0,"TD_1 Up");
      SetIndexLabel(1,"TD_1 Down");
      SetIndexLabel(2,"TD_2 Up");
      SetIndexLabel(3,"TD_2 Down");
      SetIndexLabel(4,"TD_3 Up");
      SetIndexLabel(5,"TD_3 Down");
//---- initialization done   
      return(0);
   }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//---- TODO: add your code here
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
   {
//    indent = Point * 20;
//    indent = getPriceInPixel()*10;
//    Print(indent, "   ", getPriceInPixel());
//    indent = (WindowPriceMax(0) - WindowPriceMin(0))/getPriceInPixel())*20.0;
//    Print(WindowPriceMax(0), "   ", WindowPriceMin(0), "   ", getPriceInPixel(), "   ", indent);
//    indent = 0;
      int    i, nCountedBars;
      double dCurrent;
      nCountedBars=IndicatorCounted();
//---- last counted bar will be recounted    
      if(nCountedBars<=2) i=Bars-nCountedBars-3;
      if(nCountedBars>2)
         {
            nCountedBars--;
            i=Bars-nCountedBars-1;
         }
         
      indent = 0.25*(High[i]-Low[i]);
      
//----Up and Down
      while(i>=2)
         {
//----up
            dCurrent=High[i];
            if(dCurrent>=High[i+1] && dCurrent>=High[i-1])
               {
                  TD_1_UpBuffer[i]=dCurrent + indent;
                  
                  if(dCurrent>=High[i+2] && dCurrent>=High[i-2])
                     {
                        //Print(dCurrent);
                        TD_2_UpBuffer[i]=dCurrent + indent*4;
                        
                        if(dCurrent>=High[i+3] && dCurrent>=High[i-3])
                           {
                              //Print(dCurrent);
                              TD_3_UpBuffer[i]=dCurrent + indent*7;
                           }
                     }
               }
//---- down
            dCurrent=Low[i];
            if(dCurrent<=Low[i+1] && dCurrent<=Low[i-1])
               {
//          indent = Low[i]/600 ;
                  TD_1_DownBuffer[i]=dCurrent - indent;
                  if(dCurrent<=Low[i+2] && dCurrent<=Low[i-2])
                     {
                        TD_2_DownBuffer[i]=dCurrent - indent*4;
                        if(dCurrent<=Low[i+3] && dCurrent<=Low[i-3])
                           {
                              TD_3_DownBuffer[i]=dCurrent - indent*7;
                           }
                     }
               }
            i--;
         }
//----
   return(0);
  }
//+------------------------------------------------------------------+
double getPriceInPixel()
   {
      double result = 0;
      int h = WindowHandle(Symbol(), Period());
      int rect[4];
      if(h==0) return(0);
      GetClientRect(h, rect);
      result = (WindowPriceMax() - WindowPriceMin()) / rect[3];
  // Print (result, " =  ", rect[3], "   ", WindowPriceMax(), "   ", WindowPriceMin());
      return(result);
   }

